/***** keywordMatcher.h *******************************************
 * Description: Header file for keywordMatcher program.
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * File created on Wed Sep  8 10:20:51 2004.
 *****************************************************************/
#ifndef KEYWORDMATCHER
#define KEYWORDMATCHER

#include "interface.h"
#include "sequenceData.h" 
#include "ktree.h"

KNode *initializeTree(int numChar);
KNode *createSequenceKeywordTree(Sequence *patterns, int numPat, int numChar);
KNode *createKeywordTree(char **patterns, int numPat, int numChar);
void preprocessTree(KNode *root);
void createFailureLink(KNode *source, KNode *target);
KNode *compareAndAdjust(KNode *source, KNode *target, int *found);
void addString(char *str, int id, KNode *root);
void addChild(KNode *parent, KNode *child);
KNode *findChild(KNode *parent, char c);
void examineFailureLinks(KNode *source);
void printTreeBreadthFirst(KNode *root);
int search(Sequence *patterns, char *text, KNode *root, char *header, int reverse);
void searchOnline(Sequence *patterns, char *fileName, KNode *root, Args args);
void searchSingleSeq(FILE *fp, Args *args, KTree *ktree);
void searchMultipleSeq(FILE *fp, Args *args, KTree *ktree);

#endif
